#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    uint8_t bool_uint8_0_0;
    uint8_t bool_uint8_1_0;
    uint8_t bool_uint8_2_0;
    uint8_t bool_uint8_3_0;
    uint8_t bool_uint8_4_0;
    uint8_t bool_uint8_5_0;
    uint8_t bool_uint8_6_0;
    uint8_t bool_uint8_7_0;
    uint8_t bool_uint8_8_0;
    uint8_t bool_uint8_9_0;
    uint8_t bool_uint8_10_0;
    uint8_t bool_uint8_11_0;
    uint8_t bool_uint8_12_0;
    uint8_t bool_uint8_13_0;
    uint8_t bool_uint8_14_0;
    uint8_t bool_uint8_15_0;
    uint8_t bool_uint8_16_0;
    uint8_t bool_uint8_17_0;
    uint8_t bool_uint8_18_0;
    uint8_t bool_uint8_19_0;
    uint8_t bool_uint8_20_0;
    uint8_t bool_uint8_21_0;
    uint8_t bool_uint8_22_0;
    uint8_t bool_uint8_23_0;
    uint8_t bool_uint8_24_0;
    uint8_t bool_uint8_25_0;
    uint8_t bool_uint8_26_0;
    uint8_t bool_uint8_27_0;
    uint8_t bool_uint8_28_0;
    uint8_t bool_uint8_29_0;
    uint8_t bool_uint8_30_0;
    uint8_t bool_uint8_31_0;
    uint8_t bool_uint8_32_0;
    uint8_t bool_uint8_33_0;
    uint8_t bool_uint8_34_0;
    uint8_t bool_uint8_35_0;
    uint8_t bool_uint8_36_0;
    uint8_t bool_uint8_37_0;
    uint8_t bool_uint8_38_0;
    uint8_t bool_uint8_39_0;
    uint8_t bool_uint8_40_0;
    uint8_t bool_uint8_41_0;
    uint8_t bool_uint8_42_0;
    uint8_t bool_uint8_43_0;
    uint8_t bool_uint8_44_0;
    uint8_t bool_uint8_45_0;
    uint8_t bool_uint8_46_0;
    uint8_t bool_uint8_47_0;
    uint8_t bool_uint8_48_0;
    uint8_t bool_uint8_49_0;
    uint8_t bool_uint8_50_0;
    uint8_t bool_uint8_51_0;
    uint8_t bool_uint8_52_0;
    uint8_t bool_uint8_53_0;
    uint8_t bool_uint8_54_0;
    uint8_t bool_uint8_55_0;
    uint8_t bool_uint8_56_0;
    uint8_t bool_uint8_57_0;
    uint8_t bool_uint8_58_0;
    uint8_t bool_uint8_59_0;
    uint8_t bool_uint8_60_0;
    uint8_t bool_uint8_61_0;
    uint8_t bool_uint8_62_0;
    uint8_t bool_uint8_63_0;

    if (size < 64)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&bool_uint8_0_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_1_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_2_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_3_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_4_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_5_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_6_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_7_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_8_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_9_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_10_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_11_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_12_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_13_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_14_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_15_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_16_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_17_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_18_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_19_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_20_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_21_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_22_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_23_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_24_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_25_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_26_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_27_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_28_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_29_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_30_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_31_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_32_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_33_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_34_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_35_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_36_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_37_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_38_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_39_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_40_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_41_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_42_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_43_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_44_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_45_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_46_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_47_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_48_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_49_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_50_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_51_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_52_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_53_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_54_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_55_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_56_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_57_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_58_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_59_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_60_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_61_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_62_0, &data[i], 1);
    i += 1;
    memcpy(&bool_uint8_63_0, &data[i], 1);
    i += 1;


    if (bool_uint8_0_0)
    if (!bool_uint8_1_0)
    if (bool_uint8_2_0)
    if (bool_uint8_3_0)
    if (bool_uint8_4_0)
    if (!bool_uint8_5_0)
    if (bool_uint8_6_0)
    if (bool_uint8_7_0)
    if (bool_uint8_8_0)
    if (bool_uint8_9_0)
    if (!bool_uint8_10_0)
    if (!bool_uint8_11_0)
    if (!bool_uint8_12_0)
    if (!bool_uint8_13_0)
    if (bool_uint8_14_0)
    if (bool_uint8_15_0)
    if (!bool_uint8_16_0)
    if (bool_uint8_17_0)
    if (bool_uint8_18_0)
    if (bool_uint8_19_0)
    if (!bool_uint8_20_0)
    if (bool_uint8_21_0)
    if (bool_uint8_22_0)
    if (!bool_uint8_23_0)
    if (!bool_uint8_24_0)
    if (!bool_uint8_25_0)
    if (bool_uint8_26_0)
    if (bool_uint8_27_0)
    if (!bool_uint8_28_0)
    if (bool_uint8_29_0)
    if (bool_uint8_30_0)
    if (bool_uint8_31_0)
    if (bool_uint8_32_0)
    if (!bool_uint8_33_0)
    if (!bool_uint8_34_0)
    if (bool_uint8_35_0)
    if (!bool_uint8_36_0)
    if (!bool_uint8_37_0)
    if (!bool_uint8_38_0)
    if (!bool_uint8_39_0)
    if (!bool_uint8_40_0)
    if (bool_uint8_41_0)
    if (!bool_uint8_42_0)
    if (!bool_uint8_43_0)
    if (bool_uint8_44_0)
    if (!bool_uint8_45_0)
    if (bool_uint8_46_0)
    if (!bool_uint8_47_0)
    if (bool_uint8_48_0)
    if (bool_uint8_49_0)
    if (bool_uint8_50_0)
    if (bool_uint8_51_0)
    if (bool_uint8_52_0)
    if (!bool_uint8_53_0)
    if (bool_uint8_54_0)
    if (bool_uint8_55_0)
    if (bool_uint8_56_0)
    if (bool_uint8_57_0)
    if (!bool_uint8_58_0)
    if (bool_uint8_59_0)
    if (!bool_uint8_60_0)
    if (bool_uint8_61_0)
    if (!bool_uint8_62_0)
    if (bool_uint8_63_0)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
